<template>
    <div class="waitForPlayers  container text-center">
        <br />
        <h1>You need to wait for missing players to start a new game</h1>
    </div>
</template>

<script>
    import axios from 'axios';
    export default {
        name: 'WaitForPlayers',
        data: function () {
            return {
                gameId: null,
                roundId: null,
                playerId: null,
                polling: null,
                playersNumber: null,
                storytellerId: null,
                myParams: null,
            };
        },
        methods: {
            async retrieveRoundAndGameId() {
                this.playerId = this.$route.params.playerId;
                const response = await axios.get("https://localhost:44361/api/player/" + this.playerId);
                this.roundId = response.data.roundId;
                this.gameId = response.data.gameId;
            },
            checkIfGameFull() {
                this.polling = setInterval(() => {
                    axios.get("https://localhost:44361/api/game/" + this.gameId)
                        .then(response => this.playersNumber = response.data);
                    if (this.playersNumber == 4) {
                        this.redirectToAppropriatePage();
                    }
                }, 3000);
            },
            retrieveStorytellerId() {
                 axios.get("https://localhost:44361/api/round/" + this.roundId + "/storytellerId")
                    .then(response => this.storytellerId = response.data);
            },
            generatePlayerCards() {
                axios.get("https://localhost:44361/api/card/player/" + this.playerId + "/game/" + this.gameId + "/generateCards")
            },
            redirectToAppropriatePage() {
                    this.myParams = {
                    playerId: this.playerId,
                    gameId: this.gameId,
                    roundId: this.roundId
                };
                if (this.storytellerId == this.playerId) {
                    this.$router.push({
                        name: 'storytellerPage',
                        params: this.myParams
                    });
                }
                else {
                this.$router.push({
                    name: 'playerPage',
                    params: this.myParams
                    });
                }
            },
        },
        beforeDestroy() {
            clearInterval(this.polling)
        },
        created: async function() {
            await this.retrieveRoundAndGameId();
            this.checkIfGameFull();
            this.generatePlayerCards();
            this.retrieveStorytellerId();
        }
    };
</script>